
/* 
 * Copyright (c) 1993-2003,2012 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/

#ifndef stereopixel_MSG_LIB_H
#define stereopixel_MSG_LIB_H

#include "portLib.h"
#include "csLib.h"
#include "posterLib.h"
 
#include "stereopixelType.h"

#define TIME_WAIT_REPLY           /*2000*/ 0
 



/*----------- Tailles des messages et boites aux lettres  ----------*/

/* Taille du buffer utilise dans la bal pour un mesage de taille size
 * (cf servMbox pour UNIX et h2rgnLib pour VXWORKS )
 */


#define BUF_SIZE(size) \
   (size + 4 - (size & 3) + sizeof(LETTER_HDR) + 8)

/**
 ** Boite aux lettres reception requetes 
 **/
#define  STEREOPIXEL_MBOX_NAME                  genomInstanceName("stereopixel")

#define  STEREOPIXEL_MAX_RQST_SIZE              272

#define  STEREOPIXEL_MBOX_RQST_SIZE       \
 (BUF_SIZE(STEREOPIXEL_MAX_RQST_SIZE) * SERV_NMAX_RQST_ID)

/** 
 ** Taille max repliques (serveur)
 **/
#define  STEREOPIXEL_MAX_INTERMED_REPLY_SIZE   (sizeof(int))

#define  STEREOPIXEL_MAX_REPLY_SIZE             272

/** 
 ** Taille bal clients pour reception repliques 
 **/
#define  STEREOPIXEL_CLIENT_MBOX_REPLY_SIZE   \
((BUF_SIZE(STEREOPIXEL_MAX_REPLY_SIZE) \
   + BUF_SIZE(STEREOPIXEL_MAX_INTERMED_REPLY_SIZE)) \
 * CLIENT_NMAX_RQST_ID)

/*-------------------------- Liste des requetes  -------------------------*/

#define STEREOPIXEL_INIT_RQST 0
#define STEREOPIXEL_GETCORRELATIONPARAMS_RQST 1
#define STEREOPIXEL_SETCORRELATIONPARAMS_RQST 2
#define STEREOPIXEL_GETBLOBFILTERPARAMS_RQST 3
#define STEREOPIXEL_SETBLOBFILTERPARAMS_RQST 4
#define STEREOPIXEL_COMPUTE_RQST 5
#define STEREOPIXEL_GETFRAMECOORD_RQST 6
#define STEREOPIXEL_SETFRAMECOORD_RQST 7
#define STEREOPIXEL_SETSAVEPARAMS_RQST 8
#define STEREOPIXEL_GETSAVEPARAMS_RQST 9
#define STEREOPIXEL_SAVEDISPARITY_RQST 10
#define STEREOPIXEL_CVDUMPDISPARITY_RQST 11
#define STEREOPIXEL_SAVE3DIMAGE_RQST 12
#define STEREOPIXEL_ABORT_RQST 13


/*---------------- PROTOTYPES DES FONCTIONS EXTERNES ------------------*/

#ifdef __cplusplus
extern "C" {
#endif

STATUS stereopixelClientInit (CLIENT_ID *pClientId);

STATUS stereopixelClientEnd (CLIENT_ID clientId);

int stereopixelAbortRqstSend (CLIENT_ID clientId, 
			   int *pRqstId,
			   int *activity,
			   int replyTimeOut);

int stereopixelAbortReplyRcv (CLIENT_ID clientId, 
			   int rqstId, 
			   int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			   int *bilan);

int stereopixelAbortRqstAndRcv (CLIENT_ID clientId, 
			     int *activity,
			     int *bilan);




extern STATUS stereopixelInitRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SpixName *(in_name),
					 int replyTimeOut);

extern int stereopixelInitReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int stereopixelInitRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SpixName *(in_name), 
					
					int *activity, int *bilan);

extern int stereopixelInitRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SpixName *(in_name), 
					
					int *activity,
					int *bilan);




extern STATUS stereopixelGetCorrelationParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int stereopixelGetCorrelationParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SpixCorrelParams *(out_correlParams),
			       int *bilan);

int stereopixelGetCorrelationParamsRqstAndRcv (CLIENT_ID clientId, 
				  
				 SpixCorrelParams *(out_correlParams),
				 int *bilan);




extern STATUS stereopixelSetCorrelationParamsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SpixCorrelParams *(in_correlParams),
					 int replyTimeOut);

extern int stereopixelSetCorrelationParamsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int stereopixelSetCorrelationParamsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SpixCorrelParams *(in_correlParams), 
					
					int *activity, int *bilan);

extern int stereopixelSetCorrelationParamsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SpixCorrelParams *(in_correlParams), 
					
					int *activity,
					int *bilan);




extern STATUS stereopixelGetBlobFilterParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int stereopixelGetBlobFilterParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SpixBlobFilter *(out_blobFilter),
			       int *bilan);

int stereopixelGetBlobFilterParamsRqstAndRcv (CLIENT_ID clientId, 
				  
				 SpixBlobFilter *(out_blobFilter),
				 int *bilan);




extern STATUS stereopixelSetBlobFilterParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 SpixBlobFilter *(in_blobFilter),
					 int replyTimeOut);

int stereopixelSetBlobFilterParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int stereopixelSetBlobFilterParamsRqstAndRcv (CLIENT_ID clientId, 
				 SpixBlobFilter *(in_blobFilter), 
				 
				 int *bilan);




extern STATUS stereopixelComputeRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int stereopixelComputeReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      SpixCorrelationResult *(out_correlResult),
				      int *activity, int *bilan);


extern int stereopixelComputeRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					SpixCorrelationResult *(out_correlResult),
					int *activity, int *bilan);

extern int stereopixelComputeRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					SpixCorrelationResult *(out_correlResult),
					int *activity,
					int *bilan);




extern STATUS stereopixelGetFrameCoordRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int stereopixelGetFrameCoordReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SpixFrameCoord *(out_frameCoord),
			       int *bilan);

int stereopixelGetFrameCoordRqstAndRcv (CLIENT_ID clientId, 
				  
				 SpixFrameCoord *(out_frameCoord),
				 int *bilan);




extern STATUS stereopixelSetFrameCoordRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 SpixFrameCoord *(in_frameCoord),
					 int replyTimeOut);

int stereopixelSetFrameCoordReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       
			       int *bilan);

int stereopixelSetFrameCoordRqstAndRcv (CLIENT_ID clientId, 
				 SpixFrameCoord *(in_frameCoord), 
				 
				 int *bilan);




extern STATUS stereopixelSetSaveParamsRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SpixSaveParams *(in_saveParams),
					 int replyTimeOut);

extern int stereopixelSetSaveParamsReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int stereopixelSetSaveParamsRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SpixSaveParams *(in_saveParams), 
					
					int *activity, int *bilan);

extern int stereopixelSetSaveParamsRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SpixSaveParams *(in_saveParams), 
					
					int *activity,
					int *bilan);




extern STATUS stereopixelGetSaveParamsRqstSend (CLIENT_ID clientId, 
					 int *pRqstId,
					 
					 int replyTimeOut);

int stereopixelGetSaveParamsReplyRcv (CLIENT_ID clientId, 
			       int rqstId, 
			       int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY */
			       SpixSaveParams *(out_saveParams),
			       int *bilan);

int stereopixelGetSaveParamsRqstAndRcv (CLIENT_ID clientId, 
				  
				 SpixSaveParams *(out_saveParams),
				 int *bilan);




extern STATUS stereopixelSaveDisparityRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int stereopixelSaveDisparityReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int stereopixelSaveDisparityRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int stereopixelSaveDisparityRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);




extern STATUS stereopixelCVDumpDisparityRqstSend (CLIENT_ID clientId, int *pRqstId,
					 SpixName *(in_cvDisparityFile),
					 int replyTimeOut);

extern int stereopixelCVDumpDisparityReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int stereopixelCVDumpDisparityRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					SpixName *(in_cvDisparityFile), 
					
					int *activity, int *bilan);

extern int stereopixelCVDumpDisparityRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					SpixName *(in_cvDisparityFile), 
					
					int *activity,
					int *bilan);




extern STATUS stereopixelSave3DImageRqstSend (CLIENT_ID clientId, int *pRqstId,
					 
					 int replyTimeOut);

extern int stereopixelSave3DImageReplyRcv (CLIENT_ID clientId, int rqstId, 
				      int block,  /* NO_BLOCK BLOCK_ON_FINAL_REPLY 
						     BLOCK_ON_INTERMED_REPLY */
				      
				      int *activity, int *bilan);


extern int stereopixelSave3DImageRqstAndAck (CLIENT_ID clientId, int *pRqstId,
					int replyTimeOut,
					 
					
					int *activity, int *bilan);

extern int stereopixelSave3DImageRqstAndRcv (CLIENT_ID clientId, 
					int replyTimeOut,
					 
					
					int *activity,
					int *bilan);


#ifdef __cplusplus
}
#endif
#endif /* stereopixel_MSG_LIB_H */

