
/* 
 * Copyright (c) 1993-2005 LAAS/CNRS
 * All rights reserved.
 *
 * Redistribution and use  in source  and binary  forms,  with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *
 *   1. Redistributions of  source  code must retain the  above copyright
 *      notice, this list of conditions and the following disclaimer.
 *   2. Redistributions in binary form must reproduce the above copyright
 *      notice,  this list of  conditions and the following disclaimer in
 *      the  documentation  and/or  other   materials provided  with  the
 *      distribution.
 *
 * THIS  SOFTWARE IS PROVIDED BY  THE  COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND  ANY  EXPRESS OR IMPLIED  WARRANTIES,  INCLUDING,  BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES  OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR  PURPOSE ARE DISCLAIMED. IN  NO EVENT SHALL THE COPYRIGHT
 * HOLDERS OR      CONTRIBUTORS  BE LIABLE FOR   ANY    DIRECT, INDIRECT,
 * INCIDENTAL,  SPECIAL,  EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF  SUBSTITUTE GOODS OR SERVICES; LOSS
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
 * ON ANY THEORY OF LIABILITY, WHETHER IN  CONTRACT, STRICT LIABILITY, OR
 * TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE
 * USE   OF THIS SOFTWARE, EVEN   IF ADVISED OF   THE POSSIBILITY OF SUCH
 * DAMAGE.
 */

/*------------------  Fichier gnr automatiquement ------------------*/
/*------------------  Ne pas diter manuellement !!! ------------------*/


#ifndef stereopixel_TCLSERV_CLIENT_ERROR_H
#define stereopixel_TCLSERV_CLIENT_ERROR_H

#include <server/stereopixelError.h>

/* -- MODULES ERRORS -------------------------------------------------- */

enum stereopixel_error {
	E_stereopixel_OK					  			= 0,

	/* module errors */
	E_stereopixel_CANNOT_OPEN_FILE               = S_stereopixel_CANNOT_OPEN_FILE,
	E_stereopixel_CANNOT_CREATE_POSTER           = S_stereopixel_CANNOT_CREATE_POSTER,
	E_stereopixel_NOT_ENOUGH_MEMORY              = S_stereopixel_NOT_ENOUGH_MEMORY,
	E_stereopixel_CORRELATION_FAILED             = S_stereopixel_CORRELATION_FAILED,
	E_stereopixel_UNKNOWN_CORREL_STEP            = S_stereopixel_UNKNOWN_CORREL_STEP,
	E_stereopixel_BANK_IS_NOT_STEREO             = S_stereopixel_BANK_IS_NOT_STEREO,
	E_stereopixel_NO_CAMERA_POSTER               = S_stereopixel_NO_CAMERA_POSTER,


	/* std errors */
	E_stereopixel_ACTIVITY_INTERRUPTED           = S_stereopixel_stdGenoM_ACTIVITY_INTERRUPTED,
	E_stereopixel_TOO_MANY_ACTIVITIES            = S_stereopixel_stdGenoM_TOO_MANY_ACTIVITIES,
	E_stereopixel_ACTIVITY_FAILED                = S_stereopixel_stdGenoM_ACTIVITY_FAILED,
	E_stereopixel_WAIT_ABORT_ZOMBIE_ACTIVITY     = S_stereopixel_stdGenoM_WAIT_ABORT_ZOMBIE_ACTIVITY,
	E_stereopixel_UNKNOWN_ACTIVITY               = S_stereopixel_stdGenoM_UNKNOWN_ACTIVITY,
	E_stereopixel_FORBIDDEN_ACTIVITY_TRANSITION  = S_stereopixel_stdGenoM_FORBIDDEN_ACTIVITY_TRANSITION,
	E_stereopixel_SYSTEM_ERROR                   = S_stereopixel_stdGenoM_SYSTEM_ERROR,
	E_stereopixel_ACTIVITY_ALREADY_ENDED         = S_stereopixel_stdGenoM_ACTIVITY_ALREADY_ENDED,
	E_stereopixel_WAIT_INIT_RQST                 = S_stereopixel_stdGenoM_WAIT_INIT_RQST,
	E_stereopixel_CONTROL_CODEL_ERROR            = S_stereopixel_stdGenoM_CONTROL_CODEL_ERROR,
	E_stereopixel_EXEC_TASK_SUSPENDED            = S_stereopixel_stdGenoM_EXEC_TASK_SUSPENDED,
	E_stereopixel_BAD_BLOCK_TYPE                 = S_stereopixel_stdGenoM_BAD_BLOCK_TYPE,
	E_stereopixel_BAD_POSTER_TYPE                = S_stereopixel_stdGenoM_BAD_POSTER_TYPE,

};

typedef enum stereopixel_error stereopixel_error_t;

#ifdef __cplusplus
extern "C" {
#endif

/*
 * Take an error string in parameter, and try to get the error index associated
 * to this string
 * Returns -1 in failure case (and err is not set)
 * Returns 0 in success case (and err has a sensitive value)
 */
int stereopixel_decode_error(const char* str, int *err);

/*
 * Take an integer representing an error, and try to get its textual
 * representation, in the stereopixel context.
 *
 * Returns NULL in case of failure
 */
const char* stereopixel_error_str(int err);

#ifdef __cplusplus
}
#endif


/*-------------------------- end file loading ---------------------------*/
#endif
